#!/usr/bin/env python
# -*- coding: utf-8 -*-
import pygame
from pygame.locals import *
import sys


J_LEFT  = 0
J_RIGHT = 1
J_DOWN  = 2
J_UP    = 3

J_BTN = [x for x in range(20)]



class Joystick:

    def __init__(self, id=0, mode=0):
 
        joystick = pygame.joystick
        joystick.init()
        if not joystick.get_init():

            print "Initialize error: Joystick"
            self.sticknum = 0
        else:
            self.sticknum = joystick.get_count()
            self._setup(id)
        self._mode = mode

    def ChangeStick(id):

        if id < self.sticknum:
            return self._setup(id)
        else:
            return False

    def _setup(self, id):
        try:
            self.stick = pygame.joystick.Joystick(id)
        except pygame.error, message:
            print "Joystick ID Error: %d"%id
            raise SystemExit, message
        self.stick.init()
        return self.stick.get_init()



    def get_button(self):

        inputs = []
        if self.stick.get_numbuttons() > 0:
            for i in range(self.stick.get_numbuttons()):
                inputs.append(self.stick.get_button(i))
            return tuple(inputs)
        else:
            return []

    def get_ball(self):
        inputs = []
        if self.stick.get_numballs > 0:
            for i in range(self.stick.get_numballs):
                inputs.append(self.stick.get_ball(i))
            return tuple(inputs)
                
        self.stick.get_ball(0)

    def get_axis(self):

        inputs = []
        if not self._mode == 0:

            for i in range(self.stick.get_numaxes()):
                axis = round(self.stick.get_axis(i), self.accuracy)
                inputs.append(axis)
            return (inputs)
        else:

            hat = []
            for i in range(self.stick.get_numaxes()):
                if i < 2: 
                    axis = round(self.stick.get_axis(i), self.accuracy)
                    if i == 1: 
                        hat.append(-axis)
                    else:
                        hat.append(axis)
            inputs = self._get_arrow(hat)
            return (inputs)

    def get_hat(self):

        if self.stick.get_numhats() > 0:

            inputs = self._get_arrow(self.stick.get_hat(0))
            return tuple(inputs)
        else:
            return []

    def _get_arrow(self, inputpos):

        inputs = []
        for h in inputpos:
            if h < 0:
                inputs.append(1)
                inputs.append(0)
            elif h > 0:
                inputs.append(0)
                inputs.append(1)
            else:
                inputs.append(0)
                inputs.append(0)
        return inputs
