#define BOOST_PYTHON_STATIC_LIB 
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
#include <boost/python.hpp>
#include <ode/ode.h>
#include "PyDrawStuff.h"
#include <math.h>
using namespace std;
using namespace boost::python;

double dir(dReal k){if(k>=0.0)return(1.0);else return(-1.);};

#ifdef dDOUBLE
#endif





void DrawBody::init(int x, int y, double width, double height, double range, double *vec)
{
	char com[200];

	Py_Initialize();

	sprintf(com, "display(x=%d,y=%d,width=%lf,height=%lf,range=%lf,forward=-vector(%lf,%lf,%lf))",x,y,width,height, range, vec[0], vec[1], vec[2]);
	

	object global_ns = import("__main__").attr("__dict__");

	exec( "from visual import *\n",  global_ns, global_ns );
	exec( "body = []\n",  global_ns, global_ns );
	exec( com,  global_ns, global_ns );
	
	Bodynum = 0;

}

void DrawBody::CreateGround(double *w, double *color)
{
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"ground = box(pos = (0, 0, 0), length=%lf,height=%lf,width=0.01,color=(%lf,%lf,%lf))",w[0],w[1],color[0],color[1],color[2]);
	exec( com,  global_ns, global_ns );
}

void DrawBody::drawBox(dBodyID body, dReal *sides, double *color)
{
	int i;
	bool flag = true;


	for(i = 0;i <= Bodynum;i++)
	{
		if(i < Bodynum)
		{
			if(body == BodyList[i])
			{
				flag = false;
				position(body, i);
				rotate(body, i);
			}
		}
		if(i == Bodynum)
		{
			if(flag == true)
			{
				CraeteBox(body, sides, color, i);
				BodyList[i] = body;
				Bodynum += 1;
				break;
			}
		}
	}
	


}

void DrawBody::drawSphere(dBodyID body, dReal r, double *color)
{
	int i;
	bool flag = true;


	for(i = 0;i <= Bodynum;i++)
	{
		if(i < Bodynum)
		{
			if(body == BodyList[i])
			{
				flag = false;
				position(body, i);
				rotate(body, i);
			}
		}
		if(i == Bodynum)
		{
			if(flag == true)
			{
				CraeteSphere(body, r, color, i);
				BodyList[i] = body;
				Bodynum += 1;
				break;
			}
		}
	}
	


}

void DrawBody::drawCylinder(dBodyID body, dReal r, dReal l,int direction, double *color)
{
	int i;
	bool flag = true;


	for(i = 0;i <= Bodynum;i++)
	{
		if(i < Bodynum)
		{
			if(body == BodyList[i])
			{
				flag = false;
				position(body, i);
				rotate(body, i);
			}
		}
		if(i == Bodynum)
		{
			if(flag == true)
			{
				CraeteCylinder(body, r, l, color, i, direction);
				BodyList[i] = body;
				Bodynum += 1;
				break;
			}
		}
	}
	


}

void DrawBody::drawCapsule(dBodyID body, dReal r, dReal l,int direction, double *color)
{
	int i;
	bool flag = true;


	for(i = 0;i <= Bodynum;i++)
	{
		if(i < Bodynum)
		{
			if(body == BodyList[i])
			{
				flag = false;
				rotate(body, i);
				position(body, i);
			}
		}
		if(i == Bodynum)
		{
			if(flag == true)
			{
				CraeteCapsule(body, r, l, color, i, direction);
				BodyList[i] = body;
				Bodynum += 1;
				break;
			}
		}
	}
	


}





void CraeteBox(dBodyID body, dReal *sides, double *color, int num)
{
	char com[200];
	char com2[200];
	const dReal *pos;
	pos = dBodyGetPosition(body);


	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"body.append(box(pos = (%lf, %lf, %lf), length=%lf,height=%lf,width=%lf,color=(%lf,%lf,%lf)))\n",pos[0],pos[1],pos[2],sides[0],sides[1],sides[2],color[0],color[1],color[2]);
	sprintf(com2,"body[%d].temp = [0, 1, 0, 0, 0, 0, 0]\n",num);

	exec( com,  global_ns, global_ns );
	exec( com2,  global_ns, global_ns );

}

void rotate(dBodyID body, int num)
{

	char com2[200];
	char com3[200];
	char com4[200];
	char com5[200];
	char com6[200];
	const dReal *qua;
	const dReal *pos = dBodyGetPosition(body);

	qua = dBodyGetQuaternion(body);

	dReal sum = sqrt(qua[1]*qua[1] + qua[2]*qua[2] + qua[3]*qua[3]);



	object global_ns = import("__main__").attr("__dict__");
	

	
	sprintf(com5,"body[%d].rotate(angle = %lf - body[%d].temp[0], axis =(%lf,%lf,%lf), origin = (%lf, %lf, %lf))",num,acos(qua[0])*2.0,num, qua[1]/sum,  qua[2]/sum, qua[3]/sum,pos[0],pos[1],pos[2]);
	sprintf(com6,"body[%d].temp = [%lf, %lf, %lf, %lf, %lf, %lf, %lf]",num,acos(qua[0])*2.0,qua[1]/sum, qua[2]/sum, qua[3]/sum,pos[0],pos[1],pos[2]);



	exec(com5, global_ns, global_ns );
	exec(com6, global_ns, global_ns );


}



void CraeteSphere(dBodyID body, dReal r, double *color, int num)
{
	char com[200];
	char com2[200];
	const dReal *pos;
	pos = dBodyGetPosition(body);


	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"body.append(sphere(pos = (%lf, %3f, %lf), radius = %lf,color=(%lf,%lf,%lf)))\n",pos[0],pos[1],pos[2],r,color[0],color[1],color[2]);
	sprintf(com2,"body[%d].temp = [0, 1, 0, 0, 0, 0, 0]\n",num);
	printf(com);
	exec(com,global_ns,global_ns );
	exec(com2,global_ns,global_ns );
}

void CraeteCylinder(dBodyID body, dReal r, double l, double *color, int num, int direction)
{
	char com[200];
	char com2[200];
	const dReal *pos;
	pos = dBodyGetPosition(body);


	object global_ns = import("__main__").attr("__dict__");
	if(direction == 1)sprintf(com,"body.append(cylinder(pos = (%lf, %lf, %lf), radius = %lf, axis = (%lf, 0, 0),color=(%lf,%lf,%lf)))\n",pos[0],pos[1],pos[2],r,l,color[0],color[1],color[2]);
	else if(direction == 2)sprintf(com,"body.append(cylinder(pos = (%lf, %lf, %lf), radius = %lf, axis = (0, %lf, 0),color=(%lf,%lf,%lf)))\n",pos[0],pos[1],pos[2],r,l,color[0],color[1],color[2]);
	else if(direction == 3)sprintf(com,"body.append(cylinder(pos = (%lf, %lf, %lf), radius = %lf, axis = (0, 0, %lf),color=(%lf,%lf,%lf)))\n",pos[0],pos[1],pos[2],r,l,color[0],color[1],color[2]);

	sprintf(com2,"body[%d].temp = [0, 1, 0, 0, 0, 0, 0]\n",num);

	exec( com,  global_ns, global_ns );
	exec( com2,  global_ns, global_ns );
}

void CraeteCapsule(dBodyID body, dReal r, double l, double *color, int num, int direction)
{
	char com[200];
	char com1[200];
	char com2[200];
	char com3[200];
	char com4[200];
	char com5[200];
	const dReal *pos;
	pos = dBodyGetPosition(body);


	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"group = frame(pos=(%lf, %lf, %lf))",pos[0],pos[1],pos[2]);
	if(direction == 1){
	sprintf(com2,"cylinder(pos = (%lf, %lf, %lf), radius = %lf, axis = (%lf, 0, 0),color=(%lf,%lf,%lf),frame=group)\n",pos[0]-l/2,pos[1],pos[2],r,l,color[0],color[1],color[2]);
	sprintf(com3,"sphere(pos = (%lf, %lf, %lf), radius = %lf ,color=(%lf,%lf,%lf),frame=group)\n",pos[0]+l/2,pos[1],pos[2],r,color[0],color[1],color[2]);
	sprintf(com4,"sphere(pos = (%lf, %lf, %lf), radius = %lf ,color=(%lf,%lf,%lf),frame=group)\n",pos[0]-l/2,pos[1],pos[2],r,color[0],color[1],color[2]);
	}
	if(direction == 2){
	sprintf(com2,"cylinder(pos = (%lf, %lf, %lf), radius = %lf, axis = (0, %lf, 0),color=(%lf,%lf,%lf),frame=group)\n",pos[0],pos[1]-l/2,pos[2],r,l,color[0],color[1],color[2]);
	sprintf(com3,"sphere(pos = (%lf, %lf, %lf), radius = %lf ,color=(%lf,%lf,%lf),frame=group)\n",pos[0],pos[1]+l/2,pos[2],r,color[0],color[1],color[2]);
	sprintf(com4,"sphere(pos = (%lf, %lf, %lf), radius = %lf ,color=(%lf,%lf,%lf),frame=group)\n",pos[0],pos[1]-l/2,pos[2],r,color[0],color[1],color[2]);
	}
	if(direction == 3){
	sprintf(com2,"cylinder(pos = (%lf, %lf, %lf), radius = %lf, axis = (0, 0, %lf),color=(%lf,%lf,%lf),frame=group)\n",pos[0],pos[1],pos[2]-l/2,r,l,color[0],color[1],color[2]);
	sprintf(com3,"sphere(pos = (%lf, %lf, %lf), radius = %lf ,color=(%lf,%lf,%lf),frame=group)\n",pos[0],pos[1],pos[2]+l/2,r,color[0],color[1],color[2]);
	sprintf(com4,"sphere(pos = (%lf, %lf, %lf), radius = %lf ,color=(%lf,%lf,%lf),frame=group)\n",pos[0],pos[1],pos[2]-l/2,r,color[0],color[1],color[2]);
	}
	sprintf(com1,"body.append(group)");
	sprintf(com5,"body[%d].temp = [0, 1, 0, 0, 0, 0, 0]\n",num);

	exec( com,  global_ns, global_ns );
	exec( com2,  global_ns, global_ns );
	exec( com3,  global_ns, global_ns );
	exec( com4,  global_ns, global_ns );
	exec( com1,  global_ns, global_ns );
	exec( com5,  global_ns, global_ns );

}

void position(dBodyID body, int num)
{
	char com[200];
	const dReal *pos;
	pos = dBodyGetPosition(body);


	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"body[%d].pos = (%lf, %lf, %lf)\n",num,pos[0],pos[1],pos[2]);

	exec( com,  global_ns, global_ns );
}




void glaph::init()
{
	num = 0;
	object global_ns = import("__main__").attr("__dict__");
	exec( "from visual.graph import *",  global_ns, global_ns );
	exec( "graph = []",  global_ns, global_ns );
	exec( "curves = []", global_ns, global_ns );
}

void glaph::CreateGraph(int x, int y, double xmin, double ymin, double xmax, double ymax,double width, double height, const char *xtitle, const char *ytitle)
{
	char com[200];
	sprintf(com,"graph.append(gdisplay(x=%d, y=%d,xmin = %lf, ymin = %lf,xmax = %lf, ymax = %lf, width=%lf, height=%lf, xtitle='%s', ytitle='%s'))",x,y,xmin,ymin,xmax,ymax,width,height,xtitle,ytitle);

	object global_ns = import("__main__").attr("__dict__");
	exec( com,  global_ns, global_ns );
	
}

void glaph::CreateCurve(double *color, int num)
{
	char com[200];
	sprintf(com,"curves.append(gcurve(color=(%lf, %lf, %lf), gdisplay = graph[0]))",color[0],color[1],color[2],num);
	object global_ns = import("__main__").attr("__dict__");
	exec( com,  global_ns, global_ns );
}

void glaph::drawcurve(double x, double y, int num)
{
	char com[200];
	sprintf(com,"curves[%d].plot(pos=(%lf, %lf))",num,x,y);
	object global_ns = import("__main__").attr("__dict__");
	exec( com,  global_ns, global_ns );

}


void controls::init()
{
	object global_ns = import("__main__").attr("__dict__");
	exec( "from visual.controls import *",  global_ns, global_ns );
	exec( "con = []",  global_ns, global_ns );

}


void controls::CreateControls(int x,int y,double width,double height,double range)
{
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"con.append(controls(x=%d, y=%d, width=%lf, height=%lf, range=%lf))",x,y,width,height,range);
	exec( com,  global_ns, global_ns );
}

void controls::Createbutton(double *pos, int num,double height, double width, const char *text, int cnum)
{
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"b%d = button(pos=(%lf,%lf), controls = con[%d],height=%lf, width=%lf, text='%s')",num,pos[0],pos[1],cnum,height,width,text);
	exec( com,  global_ns, global_ns );

}


void controls::Createslider(double *pos, int num,double height, double width,double *axis , int cnum)
{
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"b%d = slider(pos=(%lf,%lf), controls = con[%d], width=%lf, length=%lf, axis=(%lf,%lf,%lf))",num, pos[0], pos[1], cnum, height, width, axis[0], axis[1], axis[2]);
	exec( com,  global_ns, global_ns );
}

int controls::BReturn(int num){
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"def re():\n  return b%d.value",num);
	exec( com,  global_ns, global_ns );
	object pythonFun = global_ns["re"];
	object v = pythonFun();
	return extract<int>(v);

}

int controls::CReturn(int num){
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"def re():\n  return b%d.value",num);
	exec( com,  global_ns, global_ns );
	object pythonFun = global_ns["re"];
	object v = pythonFun();
	return extract<double>(v);

}

void controls::interact(int num)
{
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"con[%d].interact()",num);
	exec( com,  global_ns, global_ns );

}


void Joystic::init()
{
	object global_ns = import("__main__").attr("__dict__");
	exec("import sys\n""import pygame\n""from pygame.locals import *\n""import Joys \n""joy = Joys.Joystick(0)\n""pygame.init()",  global_ns, global_ns );

}

int *Joystic::ReturnJ(){
	int k[4] = {0,0,0,0};
	int i;
	object global_ns = import("__main__").attr("__dict__");
	exec("def retJ(): return joy.get_hat()",  global_ns, global_ns );
	object pythonFun = global_ns["retJ"];
	object v = pythonFun();
	for(i = 0;i < 4;i++)k[i]=extract<int>(v[i]);
	return k;



}

int *Joystic::ReturnA(){

	int k[4]={0,0,0,0};
	int i;
	object global_ns = import("__main__").attr("__dict__");
	exec("def retA():\n""   a = joy.get_axis()\n""   return a\n",  global_ns, global_ns );
	object pythonFun = global_ns["retA"];
	object v = pythonFun();
	for(i = 0;i < 4;i++)k[i]=extract<int>(v[i]);
	return k;
}

int *Joystic::ReturnB(){
	int k[8]={0,0,0,0,0,0,0,0};
	int i;
	object global_ns = import("__main__").attr("__dict__");
	exec("def retK(): return joy.get_button()",  global_ns, global_ns );
	object pythonFun = global_ns["retK"];
	object v = pythonFun();
	for(i = 0;i < 8;i++)k[i]=extract<int>(v[i]);
	return k;
}


void Joystic::execu()
{
	object global_ns = import("__main__").attr("__dict__");
	exec("for event in pygame.event.get():\n"" if event.type == QUIT:\n""  sys.exit()\n"" if event.type == KEYDOWN and event.key == K_ESCAPE:\n""  sys.exit()",  global_ns, global_ns );
            

}



void Music::init(){
	object global_ns = import("__main__").attr("__dict__");
	exec( "import pygame\n""from pygame.locals import *\n""import sys\n""pygame.init()",  global_ns, global_ns );
}

void Music::Mload(const char *c, int num){

	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"sound%d = pygame.mixer.music.load('%s')",num,c);
	exec( com,  global_ns, global_ns );
}

void Music::Sload(const char *c, int num){

	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"sound%d = pygame.mixer.Sound('%s')",num,c);
	exec( com,  global_ns, global_ns );
}

void Music::sound(int num){

	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"sound%d.play()",num);
	exec( com,  global_ns, global_ns );
}

void Music::music(int num){
	char com[200];
	object global_ns = import("__main__").attr("__dict__");
	sprintf(com,"sound%d.play(-1)",num);
	exec( com,  global_ns, global_ns );

}