#include <ode/ode.h>
#include "PyDrawStuff.h"
#include <math.h>


dWorldID world;                     
dBodyID  apple;                     
dReal    r = 0.2, m = 1.0;          
dBodyID  zimen; 
dBodyID cy;
dJointID      joint;              
glaph gp;

DrawBody draw;
double color[3] = {0.5, 0.5, 0.5};
double color2[3] = {1.0, 1.0, 1.0};

void simLoop()           
{
  dWorldStep(world,0.001);        
  //draw.drawSphere(apple, 0.2, color);
  dReal sides[3] = {0.5, 0.5, 0.5};
  //draw.drawBox(zimen, sides, color2);
  //draw.drawCylinder(cy, 0.1, 0.8, color2);
  draw.drawCapsule(cy, 0.1, 0.8, 3, color2);

}



int main(int argc, char **argv)         
{
	double w[2] = {1.0, 1.0};
	double groundC[3] = {0.2, 0.2, 0.8};
  dInitODE();                          
  world = dWorldCreate();                  
  dWorldSetGravity(world,0,0,-3.8); 

  apple = dBodyCreate(world);              
  dMass mass;                              
  dMassSetZero(&mass);                     
  dMassSetSphereTotal(&mass,m,r);          
  dBodySetMass(apple,&mass);               
  dBodySetPosition(apple, 0.0, 0.0, 2.0);  
  zimen = dBodyCreate(world);
  dMassSetZero(&mass);                     
  dMassSetBoxTotal(&mass, 10, 0.5, 0.5, 0.5);          
  dBodySetMass(zimen,&mass);               
  dBodySetPosition(zimen, 0.0, 0.0, 0.0);  
  cy = dBodyCreate(world);
  dMassSetZero(&mass);                    
  dMassSetCapsuleTotal(&mass,10,3,0.1,0.2);         
  dBodySetMass(cy,&mass);             
  dBodySetPosition(cy, 1., 0.0, 0.0); 
joint = dJointCreateHinge(world, 0);  
  dJointAttach(joint, cy, 0);
    dJointSetHingeAnchor(joint, 0.2, 0, 0.);
    dJointSetHingeAxis(joint, 0, 1,0);
	double vec[3] = {0,1,1};
  draw.init(500,200,500,500,2.5,vec); 

  const dReal *K;
  const dReal *qua;
  double theta;
  double temp;
  const dReal *pos;
  double axi[3] = {0,1,0};
  double pp[3] = {0,0,0};
  static double u = 0.0;
  //gp.init();
  //gp.CreateGraph(0, 500*2, -1.0, -1.0, 1.0, 1.0, 500, 500/2, "len", "width");
  //gp.CreateCurve(color, 0);
  		controls cont;
		cont.init();
		cont.CreateControls(0,200,500,500,60);
		cont.Createslider(pp,0,7,50,axi,0);

	Joystic joy;
	joy.init();


  
	  double s;
	  Music mu;
	  //mu.Sload(".wav",0);

  draw.CreateGround(w, groundC);
  while(1)
  {
	  cont.interact(0);
	  pos = dBodyGetPosition(cy);
	    qua = dBodyGetQuaternion(cy);
	    theta = acos(qua[0]);
        temp = sin(qua[0]);
		pos = dBodyGetPosition(cy);

		joy.execu();
 
  //gp.drawcurve(pos[0],pos[2],0);	

		simLoop();
		dJointAddHingeTorque(joint, u);
	//dBodySetPosition(cy, 0.0, 0.0, 0.0);
	//if(joy.ReturnB()[0] == 1)mu.sound(0);
		if(joy.ReturnB()[0] == 1)u += 0.01;
		u -= cont.CReturn(0)*0.0001;
  }
  
  
  dWorldDestroy(world);                    
  dCloseODE();                             
  return 0;
}